<?php

namespace Dpd;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'isAlive' => '\\Dpd\\StructType\\IsAlive',
            'isAliveResponse' => '\\Dpd\\StructType\\IsAliveResponse',
            'setAlive' => '\\Dpd\\StructType\\SetAlive',
            'setAliveResponse' => '\\Dpd\\StructType\\SetAliveResponse',
            'UserCredentials' => '\\Dpd\\StructType\\UserCredentials',
            'VerifyConfiguration' => '\\Dpd\\StructType\\VerifyConfiguration',
            'VerifyConfigurationRequest' => '\\Dpd\\StructType\\VerifyConfigurationRequest',
            'Customer' => '\\Dpd\\StructType\\Customer',
            'CustomerSmall' => '\\Dpd\\StructType\\CustomerSmall',
            'VerifyConfigurationResponse' => '\\Dpd\\StructType\\VerifyConfigurationResponse',
            'VerifyUserCredentials' => '\\Dpd\\StructType\\VerifyUserCredentials',
            'getInfo' => '\\Dpd\\StructType\\GetInfo',
            'getInfoResponse' => '\\Dpd\\StructType\\GetInfoResponse',
            'runAction' => '\\Dpd\\StructType\\RunAction',
            'RunActionRequest' => '\\Dpd\\StructType\\RunActionRequest',
            'runActionResponse' => '\\Dpd\\StructType\\RunActionResponse',
            'RunActionResponse' => '\\Dpd\\StructType\\RunActionResponse_1',
            'GetShipmentTraceSingle' => '\\Dpd\\StructType\\GetShipmentTraceSingle',
            'ShipmentDetailRequest' => '\\Dpd\\StructType\\ShipmentDetailRequest',
            'ShipmentBaseRequest' => '\\Dpd\\StructType\\ShipmentBaseRequest',
            'RequestShipmentBase' => '\\Dpd\\StructType\\RequestShipmentBase',
            'RequestBase' => '\\Dpd\\StructType\\RequestBase',
            'Options' => '\\Dpd\\StructType\\Options',
            'GetShipmentTraceSingleResponse' => '\\Dpd\\StructType\\GetShipmentTraceSingleResponse',
            'ShipmentTrace' => '\\Dpd\\StructType\\ShipmentTrace',
            'clsShipmentTraceBase' => '\\Dpd\\StructType\\ClsShipmentTraceBase',
            'SdgiData' => '\\Dpd\\StructType\\SdgiData',
            'ArrayOfClsTrace' => '\\Dpd\\ArrayType\\ArrayOfClsTrace',
            'clsTrace' => '\\Dpd\\StructType\\ClsTrace',
            'RelaisInfo' => '\\Dpd\\StructType\\RelaisInfo',
            'ArrayOfTracePhoto' => '\\Dpd\\ArrayType\\ArrayOfTracePhoto',
            'TracePhoto' => '\\Dpd\\StructType\\TracePhoto',
            'ArrayOfClsTraceDetails' => '\\Dpd\\ArrayType\\ArrayOfClsTraceDetails',
            'clsTraceDetails' => '\\Dpd\\StructType\\ClsTraceDetails',
            'ArrayOfImage' => '\\Dpd\\ArrayType\\ArrayOfImage',
            'Image' => '\\Dpd\\StructType\\Image',
            'GetShipmentTrace' => '\\Dpd\\StructType\\GetShipmentTrace',
            'GetShipmentTraceResponse' => '\\Dpd\\StructType\\GetShipmentTraceResponse',
            'ArrayOfShipmentTrace' => '\\Dpd\\ArrayType\\ArrayOfShipmentTrace',
            'GetShipmentTraceByReference' => '\\Dpd\\StructType\\GetShipmentTraceByReference',
            'ReferenceDetailRequest' => '\\Dpd\\StructType\\ReferenceDetailRequest',
            'ReferenceBaseRequest' => '\\Dpd\\StructType\\ReferenceBaseRequest',
            'GetShipmentTraceByReferenceResponse' => '\\Dpd\\StructType\\GetShipmentTraceByReferenceResponse',
            'GetLastTrace' => '\\Dpd\\StructType\\GetLastTrace',
            'GetLastTraceRequest' => '\\Dpd\\StructType\\GetLastTraceRequest',
            'GetLastTraceBaseRequest' => '\\Dpd\\StructType\\GetLastTraceBaseRequest',
            'ArrayOfParcel' => '\\Dpd\\ArrayType\\ArrayOfParcel',
            'Parcel' => '\\Dpd\\StructType\\Parcel',
            'GetLastTraceResponse' => '\\Dpd\\StructType\\GetLastTraceResponse',
            'ArrayOfGetLastTraceResponse' => '\\Dpd\\ArrayType\\ArrayOfGetLastTraceResponse',
            'GetLastTraceBaseResponse' => '\\Dpd\\StructType\\GetLastTraceBaseResponse',
            'GetLastTraceBc' => '\\Dpd\\StructType\\GetLastTraceBc',
            'GetLastTraceBcRequest' => '\\Dpd\\StructType\\GetLastTraceBcRequest',
            'ArrayOfString' => '\\Dpd\\ArrayType\\ArrayOfString',
            'GetLastTraceBcResponse' => '\\Dpd\\StructType\\GetLastTraceBcResponse',
            'ArrayOfGetLastTraceBcResponse' => '\\Dpd\\ArrayType\\ArrayOfGetLastTraceBcResponse',
        );
    }
}
